"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateHash = exports.calculateAreaPrecent = exports.extend = exports.flatObjectInArr = exports.now = exports.supportMutationObserver = exports.supportPerformanceObserver = exports.supportPerformance = void 0;
/**
 * 支持Performance对象
 */
exports.supportPerformance = function () {
    return window.performance &&
        !!window.performance.getEntriesByType &&
        !!window.performance.mark;
};
/**
 * 支持PerformanceObsever
 */
exports.supportPerformanceObserver = function () {
    return window.chrome && 'Performance' in window;
};
/**
 * 支持MutationObserver
 */
exports.supportMutationObserver = function () { return 'MutationObserver' in window; };
/**
 * @return {number} The current date timestamp
 */
exports.now = function () {
    return +new Date();
};
/**
 *
 * @param arr
 */
exports.flatObjectInArr = function (arr) {
    var kvObj = Object.create(null);
    if (Array.isArray(arr)) {
        for (var _i = 0, arr_1 = arr; _i < arr_1.length; _i++) {
            var item = arr_1[_i];
            kvObj = Object.assign(kvObj, item);
        }
    }
    return kvObj;
};
/**
 *
 * @param to
 * @param from
 */
exports.extend = function (to, from) {
    for (var key in from) {
        ;
        to[key] = from[key];
    }
    return to;
};
/**
 * 可视区域节点显示面积比例
 * @param target
 */
exports.calculateAreaPrecent = function (target) {
    var _a = target.getBoundingClientRect(), left = _a.left, right = _a.right, top = _a.top, bottom = _a.bottom, width = _a.width, height = _a.height;
    if (!width || !height)
        return 0;
    var viewWidth = right > window.innerWidth ? window.innerWidth - left :
        left >= 0 && right >= 0
            ? width
            : left < 0 && right >= 0
                ? right : 0;
    var viewHeight = bottom > window.innerHeight ? window.innerHeight - top :
        top >= 0 && bottom >= 0
            ? height
            : top < 0 && bottom >= 0
                ? bottom
                : 0;
    return Math.max((viewWidth * viewHeight) / (width * height), 0);
};
exports.generateHash = function () {
    return Number(Math.random().toString().substr(3, length) + Date.now()).toString(36);
};
//# sourceMappingURL=utils.js.map