"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var observe_1 = require("./observe");
var TTI = /** @class */ (function () {
    function TTI() {
        this.navEntry = performance.timing;
        this.resolveFn = null;
        this.longtask = [];
        this.timer = null;
        this.uniqueId = 0;
        this.networkRequests = [];
        this.completeRequest = new Map();
        this.registerListener();
    }
    TTI.prototype.getFirstConsistentlyInteractive = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.resolveFn = resolve;
            if (document.readyState === 'complete') {
                _this.startSchedulingTimerTasks();
            }
            else {
                window.addEventListener('load', function () {
                    _this.startSchedulingTimerTasks();
                });
            }
        });
    };
    TTI.prototype.startSchedulingTimerTasks = function () {
        // todo
        console.log('_incompleteRequestStarts', this.completeRequest);
        console.log('_networkRequests', this.networkRequests);
        var longTaskEnd = this.longtask.length ? this.longtask[this.longtask.length - 1].end : 0;
        var lastKnownNetworkEnd = this.computedLastKnownNetWorks(__spreadArrays(this.completeRequest.values()), this.networkRequests);
        this.recheduleTimer(Math.max(lastKnownNetworkEnd + 5000, longTaskEnd));
    };
    TTI.prototype.registerListener = function () {
        this.patchXMLHTTPRequest(this.beforeInitRequestCb.bind(this), this.afterInitRequestCb.bind(this));
        this.patchFetch(this.beforeInitRequestCb.bind(this), this.afterInitRequestCb.bind(this));
        this.registerPerformanceObserver();
    };
    TTI.prototype.registerPerformanceObserver = function () {
        return __awaiter(this, void 0, void 0, function () {
            var entries, _i, entries_1, entry;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, observe_1.default(['longtask', 'resource'])];
                    case 1:
                        entries = (_a.sent()).entries;
                        for (_i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
                            entry = entries_1[_i];
                            if (entry.entryType === 'longtask') {
                                this.longTaskFinishedCallback(entry);
                            }
                            else if (entry.entryType === 'resource') {
                                this.networkFinishedCallback(entry);
                            }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    TTI.prototype.recheduleTimer = function (earliestTime) {
        var _this = this;
        if (this.timer) {
            clearTimeout(this.timer);
        }
        this.timer = setTimeout(function () {
            _this.checkTTI();
        }, earliestTime - performance.now());
    };
    TTI.prototype.checkTTI = function () {
        var navigationStart = performance.timing.navigationStart;
        var minValue = this.getMinValue();
        var searchStart = performance.timing.domContentLoadedEventEnd - navigationStart;
        var fciVal = this.computedFirstConsistentInteractive(searchStart, minValue);
        if (fciVal) {
            this.resolveFn(fciVal);
        }
    };
    TTI.prototype.longTaskFinishedCallback = function (performanceEntry) {
        var taskEndTime = performanceEntry.startTime + performanceEntry.duration;
        this.longtask.push({
            start: performanceEntry.startTime,
            end: taskEndTime
        });
        // this.recheduleTimer(taskEndTime + 5000)
    };
    TTI.prototype.networkFinishedCallback = function (performanceEntry) {
        this.networkRequests.push({
            start: performanceEntry.fetchStart,
            end: performanceEntry.responseEnd
        });
        // this.recheduleTimer(this.computedLastKnownNetWorks([...this.completeRequest.values()], this.networkRequests) + 5000)
    };
    TTI.prototype.patchXMLHTTPRequest = function (beforeRequestCb, afterRequestCb) {
        var send = XMLHttpRequest.prototype.send;
        var requestId = this.uniqueId++;
        XMLHttpRequest.prototype.send = function () {
            var _this = this;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            beforeRequestCb(requestId);
            this.addEventListener('onreadystate', function () {
                if (_this.readyState === 4)
                    afterRequestCb(requestId);
            });
            return send.apply(this, args);
        };
    };
    TTI.prototype.patchFetch = function (beforeRequestCb, afterRequestCb) {
        var originalFetch = fetch;
        var requestId = this.uniqueId++;
        window.fetch = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return new Promise(function (resolve, reject) {
                beforeRequestCb(requestId);
                originalFetch.apply(void 0, args).then(function (res) {
                    afterRequestCb(requestId);
                    resolve(res);
                })
                    .catch(function (err) {
                    afterRequestCb(requestId);
                    reject(err);
                });
            });
        };
    };
    TTI.prototype.computedLastKnownNetWorks = function (completeRequestValues, networkRequests) {
        if (completeRequestValues.length > 2)
            return performance.now();
        var queue = [];
        for (var _i = 0, networkRequests_1 = networkRequests; _i < networkRequests_1.length; _i++) {
            var request = networkRequests_1[_i];
            queue.push({
                time: request.start,
                type: 'requestStart'
            });
            queue.push({
                time: request.end,
                type: 'responseEnd'
            });
        }
        for (var _a = 0, completeRequestValues_1 = completeRequestValues; _a < completeRequestValues_1.length; _a++) {
            var value = completeRequestValues_1[_a];
            queue.push({
                time: value,
                type: 'requestStart'
            });
        }
        queue.sort(function (a, b) { return a.time - b.time; });
        var currentActive = completeRequestValues.length;
        for (var i = queue.length - 1; i >= 0; i--) {
            var item = queue[i];
            switch (item.type) {
                case 'requestStart':
                    currentActive--;
                    break;
                case 'requestEnd':
                    currentActive++;
                    if (currentActive > 2)
                        return item.time;
                    break;
            }
        }
        return 0;
    };
    TTI.prototype.computedFirstConsistentInteractive = function (searchStart, minValue) {
        var fciVal = this.longtask.length === 0
            ? searchStart
            : this.longtask[this.longtask.length - 1].end;
        return Math.max(minValue, fciVal);
    };
    TTI.prototype.getMinValue = function () {
        var _a = this.navEntry, domContentLoadedEventEnd = _a.domContentLoadedEventEnd, navigationStart = _a.navigationStart;
        return domContentLoadedEventEnd - navigationStart;
    };
    TTI.prototype.beforeInitRequestCb = function (id) {
        this.completeRequest.set(id, performance.now());
    };
    TTI.prototype.afterInitRequestCb = function (id) {
        this.completeRequest.delete(id);
    };
    return TTI;
}());
exports.default = (function () {
    var instance = new TTI();
    return Promise.resolve(instance.getFirstConsistentlyInteractive());
});
//# sourceMappingURL=tti.js.map