"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../helpers/utils");
var eventList = [
    'onclick',
    // 'onmouseover',
    'onchange',
    'ontouchstart',
    'onblur',
    'ondrag',
];
var contentRegex = /(http|ftp|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])?/gim;
function scan(ele, eventName, whiteList, cb) {
    if (!ele)
        return;
    if (ele.nodeType !== 1)
        return;
    var hash = ele.getAttribute('data-scanhash');
    if (hash)
        return;
    ele.setAttribute('data-scanhash', utils_1.generateHash());
    var isClick = eventName === 'onclick';
    var code = ele.getAttribute(eventName);
    if (code &&
        contentRegex.test(code) &&
        code.match(contentRegex) &&
        !whiteList.includes(code.match(contentRegex)[0])) {
        ele.setAttribute(eventName, '');
        cb({
            id: utils_1.generateHash(),
            url: location.href,
            code: code,
            type: 'xss',
            ua: '',
            cookies: document.cookie,
            time: new Date(),
        });
    }
    if (isClick &&
        ele.tagName.toLowerCase() === 'a' &&
        ele.protocol === 'javascript:') {
        var code_1 = ele.href.substr(11);
        ele.href = 'javascript:void(0)';
        cb({
            id: utils_1.generateHash(),
            url: location.href,
            code: code_1,
            type: 'xss',
            ua: '',
            cookies: document.cookie,
            time: new Date(),
        });
    }
    scan(ele.parentNode, eventName, whiteList, cb);
}
function eventHook(eventName, whiteList, cb) {
    document.addEventListener(eventName.substr(2), function (e) {
        if (e.target) {
            scan(e.target, eventName, whiteList, cb);
        }
    }, true);
}
function default_1(whiteList, cb) {
    for (var _i = 0, eventList_1 = eventList; _i < eventList_1.length; _i++) {
        var k = eventList_1[_i];
        eventHook(k, whiteList, cb);
    }
}
exports.default = default_1;
//# sourceMappingURL=inline.js.map